/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// localIPEndPoints - A list of ip end points, see IpEndPointParams for details.    registerAccounts - A list of identities that can be used to initiate or receive calls and messages, see RegisterAccountParams for more details.    monitorTrunks - A list of sip uri to monitor using SIP OPTIONS.    codecs - A list of codecs supported by this instance. Options are PCMA, PCMU, G729, G722.    rtpAddress - IP address to use for media path in case different than sip address.    dtmfMode - The preferred dtmf mode, Rfc2833, Inband, dtmf, dtmf/relay.    autoAcceptCalls - When set, incoming calls are automatically accepted with a SIP RINGING.    autoAnswerCalls - When set, incoming calls are automatically answered with a SIP OK.    acceptDelay - Time in milliseconds to delay answer time in case we want to have the ring tone audible.    useMultiMediaTimers - When set, use windows rtc multimedia timers instead of dotnet timers.    hangupWhenNoRtp - When set, use rtcp to determine is rtp is available and drop the calls in case absent.    registrationInterval - Time in milliseconds between account registration.
    /// </summary>
    [DataContract]
        public partial class ConfigSipParams :  IEquatable<ConfigSipParams>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ConfigSipParams" /> class.
        /// </summary>
        /// <param name="localIpEndPoints">localIpEndPoints.</param>
        /// <param name="registerAccounts">registerAccounts.</param>
        /// <param name="monitorTrunks">monitorTrunks.</param>
        /// <param name="codecs">codecs.</param>
        /// <param name="rtpAddress">rtpAddress.</param>
        /// <param name="dtmfMode">dtmfMode.</param>
        /// <param name="autoAcceptCalls">autoAcceptCalls.</param>
        /// <param name="autoAnswerCalls">autoAnswerCalls.</param>
        /// <param name="acceptDelay">acceptDelay.</param>
        /// <param name="useMultiMediaTimers">useMultiMediaTimers.</param>
        /// <param name="hangupWhenNoRtp">hangupWhenNoRtp.</param>
        /// <param name="registrationInterval">registrationInterval.</param>
        public ConfigSipParams(List<string> localIpEndPoints = default(List<string>), List<string> registerAccounts = default(List<string>), List<string> monitorTrunks = default(List<string>), List<string> codecs = default(List<string>), string rtpAddress = default(string), string dtmfMode = default(string), bool? autoAcceptCalls = default(bool?), bool? autoAnswerCalls = default(bool?), int? acceptDelay = default(int?), bool? useMultiMediaTimers = default(bool?), bool? hangupWhenNoRtp = default(bool?), int? registrationInterval = default(int?))
        {
            this.LocalIpEndPoints = localIpEndPoints;
            this.RegisterAccounts = registerAccounts;
            this.MonitorTrunks = monitorTrunks;
            this.Codecs = codecs;
            this.RtpAddress = rtpAddress;
            this.DtmfMode = dtmfMode;
            this.AutoAcceptCalls = autoAcceptCalls;
            this.AutoAnswerCalls = autoAnswerCalls;
            this.AcceptDelay = acceptDelay;
            this.UseMultiMediaTimers = useMultiMediaTimers;
            this.HangupWhenNoRtp = hangupWhenNoRtp;
            this.RegistrationInterval = registrationInterval;
        }
        
        /// <summary>
        /// Gets or Sets LocalIpEndPoints
        /// </summary>
        [DataMember(Name="localIpEndPoints", EmitDefaultValue=false)]
        public List<string> LocalIpEndPoints { get; set; }

        /// <summary>
        /// Gets or Sets RegisterAccounts
        /// </summary>
        [DataMember(Name="registerAccounts", EmitDefaultValue=false)]
        public List<string> RegisterAccounts { get; set; }

        /// <summary>
        /// Gets or Sets MonitorTrunks
        /// </summary>
        [DataMember(Name="monitorTrunks", EmitDefaultValue=false)]
        public List<string> MonitorTrunks { get; set; }

        /// <summary>
        /// Gets or Sets Codecs
        /// </summary>
        [DataMember(Name="codecs", EmitDefaultValue=false)]
        public List<string> Codecs { get; set; }

        /// <summary>
        /// Gets or Sets RtpAddress
        /// </summary>
        [DataMember(Name="rtpAddress", EmitDefaultValue=false)]
        public string RtpAddress { get; set; }

        /// <summary>
        /// Gets or Sets DtmfMode
        /// </summary>
        [DataMember(Name="dtmfMode", EmitDefaultValue=false)]
        public string DtmfMode { get; set; }

        /// <summary>
        /// Gets or Sets AutoAcceptCalls
        /// </summary>
        [DataMember(Name="autoAcceptCalls", EmitDefaultValue=false)]
        public bool? AutoAcceptCalls { get; set; }

        /// <summary>
        /// Gets or Sets AutoAnswerCalls
        /// </summary>
        [DataMember(Name="autoAnswerCalls", EmitDefaultValue=false)]
        public bool? AutoAnswerCalls { get; set; }

        /// <summary>
        /// Gets or Sets AcceptDelay
        /// </summary>
        [DataMember(Name="acceptDelay", EmitDefaultValue=false)]
        public int? AcceptDelay { get; set; }

        /// <summary>
        /// Gets or Sets UseMultiMediaTimers
        /// </summary>
        [DataMember(Name="useMultiMediaTimers", EmitDefaultValue=false)]
        public bool? UseMultiMediaTimers { get; set; }

        /// <summary>
        /// Gets or Sets HangupWhenNoRtp
        /// </summary>
        [DataMember(Name="hangupWhenNoRtp", EmitDefaultValue=false)]
        public bool? HangupWhenNoRtp { get; set; }

        /// <summary>
        /// Gets or Sets RegistrationInterval
        /// </summary>
        [DataMember(Name="registrationInterval", EmitDefaultValue=false)]
        public int? RegistrationInterval { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ConfigSipParams {\n");
            sb.Append("  LocalIpEndPoints: ").Append(LocalIpEndPoints).Append("\n");
            sb.Append("  RegisterAccounts: ").Append(RegisterAccounts).Append("\n");
            sb.Append("  MonitorTrunks: ").Append(MonitorTrunks).Append("\n");
            sb.Append("  Codecs: ").Append(Codecs).Append("\n");
            sb.Append("  RtpAddress: ").Append(RtpAddress).Append("\n");
            sb.Append("  DtmfMode: ").Append(DtmfMode).Append("\n");
            sb.Append("  AutoAcceptCalls: ").Append(AutoAcceptCalls).Append("\n");
            sb.Append("  AutoAnswerCalls: ").Append(AutoAnswerCalls).Append("\n");
            sb.Append("  AcceptDelay: ").Append(AcceptDelay).Append("\n");
            sb.Append("  UseMultiMediaTimers: ").Append(UseMultiMediaTimers).Append("\n");
            sb.Append("  HangupWhenNoRtp: ").Append(HangupWhenNoRtp).Append("\n");
            sb.Append("  RegistrationInterval: ").Append(RegistrationInterval).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ConfigSipParams);
        }

        /// <summary>
        /// Returns true if ConfigSipParams instances are equal
        /// </summary>
        /// <param name="input">Instance of ConfigSipParams to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ConfigSipParams input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.LocalIpEndPoints == input.LocalIpEndPoints ||
                    this.LocalIpEndPoints != null &&
                    input.LocalIpEndPoints != null &&
                    this.LocalIpEndPoints.SequenceEqual(input.LocalIpEndPoints)
                ) && 
                (
                    this.RegisterAccounts == input.RegisterAccounts ||
                    this.RegisterAccounts != null &&
                    input.RegisterAccounts != null &&
                    this.RegisterAccounts.SequenceEqual(input.RegisterAccounts)
                ) && 
                (
                    this.MonitorTrunks == input.MonitorTrunks ||
                    this.MonitorTrunks != null &&
                    input.MonitorTrunks != null &&
                    this.MonitorTrunks.SequenceEqual(input.MonitorTrunks)
                ) && 
                (
                    this.Codecs == input.Codecs ||
                    this.Codecs != null &&
                    input.Codecs != null &&
                    this.Codecs.SequenceEqual(input.Codecs)
                ) && 
                (
                    this.RtpAddress == input.RtpAddress ||
                    (this.RtpAddress != null &&
                    this.RtpAddress.Equals(input.RtpAddress))
                ) && 
                (
                    this.DtmfMode == input.DtmfMode ||
                    (this.DtmfMode != null &&
                    this.DtmfMode.Equals(input.DtmfMode))
                ) && 
                (
                    this.AutoAcceptCalls == input.AutoAcceptCalls ||
                    (this.AutoAcceptCalls != null &&
                    this.AutoAcceptCalls.Equals(input.AutoAcceptCalls))
                ) && 
                (
                    this.AutoAnswerCalls == input.AutoAnswerCalls ||
                    (this.AutoAnswerCalls != null &&
                    this.AutoAnswerCalls.Equals(input.AutoAnswerCalls))
                ) && 
                (
                    this.AcceptDelay == input.AcceptDelay ||
                    (this.AcceptDelay != null &&
                    this.AcceptDelay.Equals(input.AcceptDelay))
                ) && 
                (
                    this.UseMultiMediaTimers == input.UseMultiMediaTimers ||
                    (this.UseMultiMediaTimers != null &&
                    this.UseMultiMediaTimers.Equals(input.UseMultiMediaTimers))
                ) && 
                (
                    this.HangupWhenNoRtp == input.HangupWhenNoRtp ||
                    (this.HangupWhenNoRtp != null &&
                    this.HangupWhenNoRtp.Equals(input.HangupWhenNoRtp))
                ) && 
                (
                    this.RegistrationInterval == input.RegistrationInterval ||
                    (this.RegistrationInterval != null &&
                    this.RegistrationInterval.Equals(input.RegistrationInterval))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.LocalIpEndPoints != null)
                    hashCode = hashCode * 59 + this.LocalIpEndPoints.GetHashCode();
                if (this.RegisterAccounts != null)
                    hashCode = hashCode * 59 + this.RegisterAccounts.GetHashCode();
                if (this.MonitorTrunks != null)
                    hashCode = hashCode * 59 + this.MonitorTrunks.GetHashCode();
                if (this.Codecs != null)
                    hashCode = hashCode * 59 + this.Codecs.GetHashCode();
                if (this.RtpAddress != null)
                    hashCode = hashCode * 59 + this.RtpAddress.GetHashCode();
                if (this.DtmfMode != null)
                    hashCode = hashCode * 59 + this.DtmfMode.GetHashCode();
                if (this.AutoAcceptCalls != null)
                    hashCode = hashCode * 59 + this.AutoAcceptCalls.GetHashCode();
                if (this.AutoAnswerCalls != null)
                    hashCode = hashCode * 59 + this.AutoAnswerCalls.GetHashCode();
                if (this.AcceptDelay != null)
                    hashCode = hashCode * 59 + this.AcceptDelay.GetHashCode();
                if (this.UseMultiMediaTimers != null)
                    hashCode = hashCode * 59 + this.UseMultiMediaTimers.GetHashCode();
                if (this.HangupWhenNoRtp != null)
                    hashCode = hashCode * 59 + this.HangupWhenNoRtp.GetHashCode();
                if (this.RegistrationInterval != null)
                    hashCode = hashCode * 59 + this.RegistrationInterval.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
